<?php

namespace Sukellos\Admin;

use Sukellos\Dao\WP_Scrapio_Gmap_Entities_Dao;
use Sukellos\WP_Sukellos_Scrapio_Loader;
use Sukellos\WPFw\AdminBuilder\Item_Type;
use Sukellos\WPFw\Utils\WP_Log;
use Sukellos\WPFw\WP_Plugin_Admin;
use Sukellos\WPFw\AdminBuilder\Admin_Builder;
use Sukellos\WPFw\Singleton;

defined( 'ABSPATH' ) or exit;

/**
 * Admin class.
 *
 * @since 1.0.0
 */
class WP_Scrapio_Admin_Entity extends WP_Plugin_Admin {

    // Use Trait Singleton
    use Singleton;

    /**
     * Default init method called when instance created
     * This method can be overridden if needed.
     *
     * @since 1.0.0
     * @access protected
     */
    public function init() {

        parent::init();
    }

    /**
     *          ===============
     *      =======================
     *  ============ HOOKS ===========
     *      =======================
     *          ===============
     */


    /***
     * Adding CSS and JS into header
     * Default add assets/admin.css and assets/admin.js
     */
    public function admin_enqueue_scripts() {
    }

    /***
     * Admin page
     * Settings managed by main Sukellos Fw Tools admin
     */
    public function create_items()
    {
        // To improve code readability
        $plugin_name = WP_Sukellos_Scrapio_Loader::instance()->get_name();
        $options_suffix_param = WP_Sukellos_Scrapio_Loader::instance()->get_options_suffix_param();
/*
        // Check if license restriction applied
        if ( $this->is_license_restricted() ) {

            // Admin page.
            $admin_page = Admin_Builder::instance()->create_admin_page(
                array(
                    'name' => $plugin_name.' - '.__( 'Settings', 'wp-sukellos-fw' ),
                    'title' => __( 'Settings', 'wp-sukellos-fw' ),
                    'id' => $options_suffix_param . '_settings',
                    'capability' => 'manage_options',
                    'parent_id' => $options_suffix_param.'_scrapio_admin_page',
                    'icon' => 'dashicons-smiley', // Menu icon for top level menus only https://developer.wordpress.org/resource/dashicons/#editor-paste-word
                    'position' => 27,
                    'use_tabs' => false,
                )
            );

            // Create a note
            $admin_page->create_note(
                array(
                    // Common
                    'id' => $options_suffix_param.'_note_license_invalid2',
                    'name' => __( 'ATTENTION', 'wp-sukellos-fw' ),
                    'desc' => __( 'Thank you to validate your license, in order to be able to use all the functionalities of this plugin. If you do not yet have a license key, you can purchase one <a href="'.WP_Sukellos_Scrapio_Loader::instance()->get_sales_page_url().'" target="_blank">here</a>', 'wp-sukellos-fw' ),
                    'sukellos_rule_exception' => true,
                )
            );
            return;
        }
*/
        // Admin page.
        $admin_page = Admin_Builder::instance()->create_admin_page(
            array(
                'name' => $plugin_name.' - '.__( 'Gmap Entity', 'wp-sukellos-fw' ),
                'title' => __( 'Gmap Entity', 'wp-sukellos-fw' ),
                'id' => $options_suffix_param . '_entity',
                'capability' => 'manage_options',
                'parent_id' => $options_suffix_param.'_entities_list',
                'icon' => 'dashicons-smiley', // Menu icon for top level menus only https://developer.wordpress.org/resource/dashicons/#editor-paste-word
                'position' => 29,
                'desc' => __( 'Detailed of a previously gmap entity imported from Scrap.io', 'wp-sukellos-fw' ),
            )
        );

        if ( array_key_exists( 'entity_id', $_GET ) ) {

            $entity_id = $_GET[ 'entity_id' ];

            $html_crm_retour = '<p><a href="'.get_site_url().'/wp-admin/admin.php?page='.$options_suffix_param.'_entities_list">Retour</a></p>';

            $admin_page->create_content(
                array(
                    'id' => $options_suffix_param.'_admin_page_crm_structure_retour',
                    'name' => __('Back', 'wp-sukellos-fw' ),
                    'desc' => '',
                    'content' => $html_crm_retour,
                )
            );

            // Load entity content
            $entity_id = $_GET['entity_id'];
            $gmap_entity = WP_Scrapio_Gmap_Entities_Dao::instance()->get_gmap_entity( $entity_id );

            WP_Log::debug( __METHOD__, ['$gmap_entity'=>$gmap_entity ], 'wp-sukellos-fw' );

            $html_content = '
                <h2>'.$gmap_entity['name'].'</h2>
                <p><strong>entity_id:</strong> '.$gmap_entity['entity_id'].'</p>
                <p><strong>google_id:</strong> '.$gmap_entity['google_id'].'</p>
                <p><strong>place_id:</strong> '.$gmap_entity['place_id'].'</p>
                <p><strong>name:</strong> '.$gmap_entity['name'].'</p>
                ';

            $html_content .= '<h3>'.__( 'Scrap.io - Gmap search', 'wp-sukellos-fw' ).'</h3>';
            $html_content .= '
                <p><strong>type:</strong> '.$gmap_entity['type'].'</p>
                <p><strong>country_code:</strong> '.$gmap_entity['country_code'].'</p>
                <p><strong>admin1:</strong> '.$gmap_entity['admin1'].'</p>
                <p><strong>admin2:</strong> '.$gmap_entity['admin2'].'</p>
                <p><strong>zip:</strong> '.$gmap_entity['zip'].'</p>
                <p><strong>city:</strong> '.$gmap_entity['city'].'</p>
            ';

            // JSON encoding of entity_json
            $html_content .= '<h3>'.__( 'Scrap.io - Gmap search - Detailed response', 'wp-sukellos-fw' ).'</h3>';
            $html_content .= '<p></p><pre style="font-size: 10px">'.print_r( json_decode( $gmap_entity['entity_json'], true ), true ).'</pre></p>';
//                $output = print_r($raw_response, true);
//            wp_send_json_success( '<pre style="font-size: 10px">'.$output.'</pre>' );

            // This content will be filled by its self filter: sukellos_fw/admin_builder/field/'.WP_Sukellos_Scrapio_Loader::instance()->get_options_suffix_param().'_header_crud_gmap_entities_list_content
            $admin_page->create_content(
                array(
                    'id' => $options_suffix_param . '_header_gmap_entity_detail_content',
                    'name' => __( 'Gmap Entity detail', 'wp-sukellos-fw' ),
                    'content' => $html_content,
                )
            );
        }

    }

}