<?php

namespace Sukellos;

use Sukellos\WPFw\Utils\WP_Log;
use Sukellos\WPFw\WP_Plugin;
use Sukellos\WPFw\Singleton;

defined( 'ABSPATH' ) or exit;

/**
 * Wordpress Sukellos Enable Classic Editor plugin class.
 *
 * @since 1.0.0
 */
class WP_Sukellos_Scrapio extends WP_Plugin {

    // Use Trait Singleton
    use Singleton;

    /**
     * Default init method called when instance created
     * This method can be overridden if needed.
     *
     * @since 1.0.0
     * @access protected
     */
    public function init() {

        // Load text domain for translations
        load_plugin_textdomain( WP_Sukellos_Scrapio_Loader::instance()->get_text_domain(), false, WP_Sukellos_Scrapio_Loader::instance()->get_text_domain().'/languages/' );

        self::$instance->enable_admin();

        // Main manager
        WP_Scrapio_Importer::instance();
        WP_Scrapio_Scheduler::instance();
        WP_Scrapio_CPT_Mapper::instance();

        WP_Log::info( 'WP-Sukellos-Scrapio init OK!' );

/*
        // TEST
        $photos = new Photos();
        $acf_field_name = $photos->get_acf_field_name();
        $photos_field = get_field( $acf_field_name, 333 );
        WP_Log::debug( __METHOD__.' DEBUG', ['$photos_field'=>$photos_field, 'selector'=>$acf_field_name], 'wp-sukellos-fw' );
*/
/*        $wh = new Working_Hours();
        foreach ( Working_Hours::DAYS_OF_THE_WEEK as $day_of_the_week => $label ) {

            $acf_field_name = $wh->get_acf_field_name();
            $wh_field_closed = get_field( $acf_field_name.'_'.$day_of_the_week.'_closed', 223 );
            WP_Log::debug( __METHOD__.' DEBUG', ['$label'=>$label, '$wh_field_closed'=>$wh_field_closed, 'selector'=>$acf_field_name], 'wp-sukellos-fw' );

            $acf_field_key = $wh->get_acf_field_key();
            if( !$wh_field_closed && have_rows( $acf_field_key.'_'.$day_of_the_week.'_range', 223 ) ) {

                WP_Log::debug( __METHOD__.' DEBUG - '.$acf_field_key.'_'.$day_of_the_week.'_range have rows', [], 'wp-sukellos-fw' );

                while ( have_rows( $acf_field_key.'_'.$day_of_the_week.'_range', 223 ) ) {

                    the_row();

                    $sub_value_opening = get_sub_field( $acf_field_key.'_'.$day_of_the_week.'_opening' );
                    $sub_value_closing = get_sub_field( $acf_field_key.'_'.$day_of_the_week.'_closing' );
                    WP_Log::debug( __METHOD__.' DEBUG', ['$sub_value_opening'=>$sub_value_opening, '$sub_value_closing'=>$sub_value_closing], 'wp-sukellos-fw' );
                }
            }
        }*/
    }

    /**
     * Initializes the custom post types.
     * Called on init and on activation hooks
     *
     * Must be override to create custom post types for the plugin
     *
     * @since 1.0.0
     */
    public function init_custom_post_types() {

        // No custom post types...
    }

    /**
     *          ===============
     *      =======================
     *  ============ HOOKS ===========
     *      =======================
     *          ===============
     */


}
