<?php

namespace Sukellos;

use Exception;

defined( 'ABSPATH' ) or exit;

class WP_Scrapio_Exception extends Exception {

    // Sukellos error codes
    const GMAP_SEARCH_ALREADY_NI_PROGRESS = 'gmap_search_already_ni_progress';
    const GMAP_SEARCH_MISSING_COUNTRY_CODE = 'gmap_search_missing_country_code';
    const GMAP_SEARCH_MISSING_TYPE = 'gmap_search_missing_type';
    const GMAP_SEARCH_IN_CACHE = 'gmap_search_in_cache';
    // Scrap.io error codes
    const SCRAPIO_UNAUTHORIZED = 'scrapio_unauthorized';
    const SCRAPIO_NOT_FOUND = 'scrapio_not_found';
    const SCRAPIO_METHOD_NOT_ALLOWED = 'scrapio_method_not_allowed';
    const SCRAPIO_UNPROCESSABLE_ENTITY = 'scrapio_unprocessable_entity';
    const SCRAPIO_TOO_MANY_REQUESTS = 'scrapio_too_many_requests';
    const SCRAPIO_INTERNAL_SERVER_ERROR = 'scrapio_internal_server_error';
    const SCRAPIO_SERVICE_UNAVAILABLE = 'scrapio_service_unavailable';
    const ERROR_CODES = array(
        self::GMAP_SEARCH_ALREADY_NI_PROGRESS => 1,
        self::GMAP_SEARCH_MISSING_COUNTRY_CODE => 2,
        self::GMAP_SEARCH_MISSING_TYPE => 3,
        self::GMAP_SEARCH_IN_CACHE => 4,
        self::SCRAPIO_UNAUTHORIZED => 401,
        self::SCRAPIO_NOT_FOUND => 404,
        self::SCRAPIO_METHOD_NOT_ALLOWED => 405,
        self::SCRAPIO_UNPROCESSABLE_ENTITY => 422,
        self::SCRAPIO_TOO_MANY_REQUESTS => 429,
        self::SCRAPIO_INTERNAL_SERVER_ERROR => 500,
        self::SCRAPIO_SERVICE_UNAVAILABLE => 503,
    );

    const ERROR_MESSAGES = array(
        self::GMAP_SEARCH_ALREADY_NI_PROGRESS => 'Gmap search already in progress',
        self::GMAP_SEARCH_MISSING_COUNTRY_CODE => 'Missing required parameter: country',
        self::GMAP_SEARCH_MISSING_TYPE => 'Missing required parameter: type',
        self::GMAP_SEARCH_IN_CACHE => 'Gmap search is already stored in database. No need to import again from Scrap.io.',
        self::SCRAPIO_UNAUTHORIZED => 'Unauthorized -- Your API key is wrong, or not authorized to access this endpoint.',
        self::SCRAPIO_NOT_FOUND => 'Not Found -- The resource was not be found.',
        self::SCRAPIO_METHOD_NOT_ALLOWED => 'Method Not Allowed -- You tried to access an endpoint with an invalid method.',
        self::SCRAPIO_UNPROCESSABLE_ENTITY => 'Unprocessable entity -- Your request is invalid.',
        self::SCRAPIO_TOO_MANY_REQUESTS => '429	Too Many Requests -- You\'re making too many resquests! Slow down!',
        self::SCRAPIO_INTERNAL_SERVER_ERROR => 'Internal Server Error -- We had a problem with our server. Try again later.',
        self::SCRAPIO_SERVICE_UNAVAILABLE => 'Service Unavailable -- We\'re temporarily offline for maintenance. Please try again later.',
    );
}