<?php

namespace Sukellos;

defined( 'ABSPATH' ) or exit;

/**
 * Place Id field Class
 *
 * @since 1.0.0
 */
class Place_Id extends Field {

    protected $field_id = 'google_place_id';
    protected $field_label = 'Place id';

    /**
     * ACF name of the field
     * @return string
     */
    public function get_acf_field_name() {

        return $this->field_id;
    }

    /**
     * ACF key of the field (field_...)
     * @return string
     */
    public function get_acf_field_key() {

        return 'field_'.$this->field_id;
    }

    /**
     * Get the specific ACF Custom Field definition
     */
    public function get_specific_acf_field_definition() {

        return array(

            'type' => 'text',

            'wrapper' => array(
                'width' => '',
                'class' => 'hidden_acf_field',
                'id' => '',
            ),

        );
    }
}
