<?php

namespace Sukellos;

use Sukellos\WPFw\Utils\WP_Log;
use DateTime;

defined( 'ABSPATH' ) or exit;

/**
 * Working_Hours field Class
 *
 * @since 1.0.0
 */
class Working_Hours extends Field {

    const DAYS_OF_THE_WEEK = array(
            'monday' => 'Monday',
            'tuesday' => 'Tuesday',
            'wednesday' => 'Wednesday',
            'thursday' => 'Thursday',
            'friday' => 'Friday',
            'saturday' => 'Saturday',
            'sunday' => 'Sunday',
        );

    // "working_hours": {
    //		"friday": [
    //			"10-am-1-pm",
    //			"2-10-pm"
    //		],
    //		"monday": "2-10-pm",
    //		"sunday": "closed",
    //		"tuesday": "2-10-pm",
    //		"saturday": "930-am-6-pm",
    //		"thursday": "2-10-pm",
    //		"wednesday": "10-am-10-pm"
    //	},
    protected $field_id = 'working_hours';
    protected $field_label = 'Working hours';

    /**
     * Constructor
     *
     * @param $settings
     */
    public function __construct() {

        parent::__construct();

        $this->acf_field_definition = $this->get_specific_acf_field_definition();
    }

    /**
     * Get the specific ACF Custom Field definition
     */
    public function get_specific_acf_field_definition() {

        // add_action( 'acf/include_fields', function() {
        //	if ( ! function_exists( 'acf_add_local_field_group' ) ) {
        //		return;
        //	}
        //
        //	acf_add_local_field_group( array(
        //	'key' => 'group_660ebf7974abb',
        //	'title' => 'Wordking hours',
        //	'fields' => array(
        //		array(
        //			'key' => 'field_66100830d9aa8',
        //			'label' => 'Lundi',
        //			'name' => '',
        //			'aria-label' => '',
        //			'type' => 'tab',
        //			'instructions' => '',
        //			'required' => 0,
        //			'conditional_logic' => 0,
        //			'wrapper' => array(
        //				'width' => '',
        //				'class' => '',
        //				'id' => '',
        //			),
        //			'placement' => 'top',
        //			'endpoint' => 0,
        //		),
        //		array(
        //			'key' => 'field_666b16482e100',
        //			'label' => 'Fermé',
        //			'name' => 'ferme',
        //			'aria-label' => '',
        //			'type' => 'true_false',
        //			'instructions' => '',
        //			'required' => 0,
        //			'conditional_logic' => 0,
        //			'wrapper' => array(
        //				'width' => '',
        //				'class' => '',
        //				'id' => '',
        //			),
        //			'message' => '',
        //			'default_value' => 0,
        //			'ui_on_text' => '',
        //			'ui_off_text' => '',
        //			'ui' => 1,
        //		),
        //		array(
        //			'key' => 'field_666b16b1599ad',
        //			'label' => 'Créneaux',
        //			'name' => 'lundi_creneaux',
        //			'aria-label' => '',
        //			'type' => 'repeater',
        //			'instructions' => '',
        //			'required' => 0,
        //			'conditional_logic' => array(
        //				array(
        //					array(
        //						'field' => 'field_666b16482e100',
        //						'operator' => '!=',
        //						'value' => '1',
        //					),
        //				),
        //			),
        //			'wrapper' => array(
        //				'width' => '',
        //				'class' => '',
        //				'id' => '',
        //			),
        //			'layout' => 'table',
        //			'pagination' => 0,
        //			'min' => 0,
        //			'max' => 0,
        //			'collapsed' => '',
        //			'button_label' => 'Ajouter un élément',
        //			'rows_per_page' => 20,
        //			'sub_fields' => array(
        //				array(
        //					'key' => 'field_666b16d1599ae',
        //					'label' => 'Ouverture',
        //					'name' => 'lundi_ouverture',
        //					'aria-label' => '',
        //					'type' => 'time_picker',
        //					'instructions' => '',
        //					'required' => 0,
        //					'conditional_logic' => 0,
        //					'wrapper' => array(
        //						'width' => '',
        //						'class' => '',
        //						'id' => '',
        //					),
        //					'display_format' => 'H:i',
        //					'return_format' => 'H:i',
        //					'parent_repeater' => 'field_666b16b1599ad',
        //				),
        //				array(
        //					'key' => 'field_666b1702cda30',
        //					'label' => 'Fermeture',
        //					'name' => 'lundi_fermeture',
        //					'aria-label' => '',
        //					'type' => 'time_picker',
        //					'instructions' => '',
        //					'required' => 0,
        //					'conditional_logic' => 0,
        //					'wrapper' => array(
        //						'width' => '',
        //						'class' => '',
        //						'id' => '',
        //					),
        //					'display_format' => 'H:i',
        //					'return_format' => 'H:i',
        //					'parent_repeater' => 'field_666b16b1599ad',
        //				),
        //			),
        //		),
        //	),
        //	'location' => array(
        //		array(
        //			array(
        //				'param' => 'post_type',
        //				'operator' => '==',
        //				'value' => 'yogi',
        //			),
        //		),
        //	),
        //	'menu_order' => 0,
        //	'position' => 'normal',
        //	'style' => 'default',
        //	'label_placement' => 'top',
        //	'instruction_placement' => 'label',
        //	'hide_on_screen' => '',
        //	'active' => true,
        //	'description' => '',
        //	'show_in_rest' => 0,
        //) );
        //} );


        $fields = array();
        foreach ( self::DAYS_OF_THE_WEEK as $day_of_the_week => $label ) {

            // Tab
            $fields[] = array(
                    'key' => $this->get_acf_field_key().'_'.$day_of_the_week.'_tab',
                    'label' => __( $label, 'wp-sukellos-fw' ),
                    'name' => '',
                    'aria-label' => '',
                    'type' => 'tab',
                    'instructions' => '',
                    'required' => 0,
                    'conditional_logic' => 0,
                    'wrapper' => array(
                        'width' => '',
                        'class' => '',
                        'id' => '',
                    ),
                    'placement' => 'top',
                    'endpoint' => 0,
                );

            // Close
            $fields[] = array(
                'key' => $this->get_acf_field_key().'_'.$day_of_the_week.'_closed',
                'label' => __( 'Closed', 'wp-sukellos-fw' ),
                'name' => $this->get_acf_field_name().'_'.$day_of_the_week.'_closed',
                'aria-label' => '',
                'type' => 'true_false',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => 0,
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => 1,
                'ui_on_text' => '',
                'ui_off_text' => '',
                'ui' => 1,
            );

            // Open 24h
            $fields[] = array(
                'key' => $this->get_acf_field_key().'_'.$day_of_the_week.'_open_24h',
                'label' => __( 'Open 24h', 'wp-sukellos-fw' ),
                'name' => $this->get_acf_field_name().'_'.$day_of_the_week.'_open_24h',
                'aria-label' => '',
                'type' => 'true_false',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => array(
                    array(
                        array(
                            'field' => $this->get_acf_field_key().'_'.$day_of_the_week.'_closed',
                            'operator' => '!=',
                            'value' => '1',
                        ),
                    ),
                ),
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'message' => '',
                'default_value' => 0,
                'ui_on_text' => '',
                'ui_off_text' => '',
                'ui' => 1,
            );

            // Range repeater
            $fields[] = array(
                'key' => $this->get_acf_field_key().'_'.$day_of_the_week.'_range',
                'label' => __( 'Range', 'wp-sukellos-fw' ),
                'name' => $this->get_acf_field_name().'_'.$day_of_the_week.'_range',
                'aria-label' => '',
                'type' => 'repeater',
                'instructions' => '',
                'required' => 0,
                'conditional_logic' => array(
                    array(
                        array(
                            'field' => $this->get_acf_field_key().'_'.$day_of_the_week.'_closed',
                            'operator' => '!=',
                            'value' => '1',
                        ),
                        array(
                            'field' => $this->get_acf_field_key().'_'.$day_of_the_week.'_open_24h',
                            'operator' => '!=',
                            'value' => '1',
                        ),
                    ),
                ),
                'wrapper' => array(
                    'width' => '',
                    'class' => '',
                    'id' => '',
                ),
                'layout' => 'table',
                'pagination' => 0,
                'min' => 0,
                'max' => 0,
                'collapsed' => '',
                'button_label' => __( 'Add an element', 'wp-sukellos-fw' ),
                'rows_per_page' => 20,
                'sub_fields' => array(
                    array(
                        'key' => $this->get_acf_field_key().'_'.$day_of_the_week.'_opening',
                        'label' => __( 'Opening', 'wp-sukellos-fw' ),
                        'name' => $this->get_acf_field_name().'_'.$day_of_the_week.'_opening',
                        'aria-label' => '',
                        'type' => 'time_picker',
                        'instructions' => '',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array(
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                        'display_format' => 'H:i',
                        'return_format' => 'H:i',
                        'parent_repeater' => $this->get_acf_field_key().'_'.$day_of_the_week.'_range',
                    ),
                    array(
                        'key' => $this->get_acf_field_key().'_'.$day_of_the_week.'_closing',
                        'label' => __( 'Closing', 'wp-sukellos-fw' ),
                        'name' => $this->get_acf_field_name().'_'.$day_of_the_week.'_closing',
                        'aria-label' => '',
                        'type' => 'time_picker',
                        'instructions' => '',
                        'required' => 0,
                        'conditional_logic' => 0,
                        'wrapper' => array(
                            'width' => '',
                            'class' => '',
                            'id' => '',
                        ),
                        'display_format' => 'H:i',
                        'return_format' => 'H:i',
                        'parent_repeater' => $this->get_acf_field_key().'_'.$day_of_the_week.'_range',
                    ),
                ),
            );

        }
        return $fields;
    }

    /**
     * Insert the field as a WordPress ACF Custom Field
     *
     * MUST be called after set_data()
     *
     * MUST be overriden if the type is complex (other than simple text, url...)
     */
    public function update_acf_field( $post_id ) {

        if ( is_null( $this->data ) ) {

            WP_Log::debug( __METHOD__.' Data is null', [ ], 'wp-sukellos-fw' );
            return false;
        }

        // Get its self data from gmap entity JSON data
        if ( !isset( $this->data[$this->field_id] ) || is_null( $this->data[$this->field_id] ) || empty( $this->data[$this->field_id] )  )  {

            WP_Log::debug( __METHOD__.' Not isset', [ ], 'wp-sukellos-fw' );
            return false;
        }

        $working_hours = $this->data[$this->field_id];
        WP_Log::debug( __METHOD__, ['$working_hours'=>$working_hours ], 'wp-sukellos-fw' );

        // Get its self data from gmap entity JSON data
        $acf_hours = array();
        foreach ( self::DAYS_OF_THE_WEEK as $day => $label ) {

            if ( isset( $working_hours[ $day ] ) ) {

                $times = $working_hours[ $day ];
                WP_Log::debug( __METHOD__, ['$day'=>$day, '$times'=>$times ], 'wp-sukellos-fw' );
                if ( !is_array( $times ) ) {

                    if ( is_null( $times ) || ( strtolower( $times ) === 'closed' ) ) {

                        // Closed to true
                        update_field( $this->get_acf_field_name().'_'.$day.'_closed', true, $post_id );
                        WP_Log::debug( __METHOD__.' - Closed', ['$day'=>$day ], 'wp-sukellos-fw' );

                    } elseif ( strtolower( $times ) === 'open-24-hours' ) {

                        // FIXME add a open-24-hours type ?
                        // Closed to false
                        update_field( $this->get_acf_field_name().'_'.$day.'_closed', false, $post_id );
                        update_field( $this->get_acf_field_name().'_'.$day.'_open_24h', true, $post_id );
                        WP_Log::debug( __METHOD__.' - Not closed (open-24-hours)', ['$day'=>$day ], 'wp-sukellos-fw' );

                    } else {
                        // Closed to false
                        update_field( $this->get_acf_field_name().'_'.$day.'_closed', false, $post_id );
                        update_field( $this->get_acf_field_name().'_'.$day.'_open_24h', false, $post_id );

                        // Build repeater
                        $repeater = array();
                        $ranges = $this->format_time_range( $times );
                        if ( !empty( $ranges ) ) {

                            $repeater[] = array(
                                $this->get_acf_field_name().'_'.$day.'_opening' => $ranges['opening'] ,
                                $this->get_acf_field_name().'_'.$day.'_closing' => $ranges['closing'] ,
                            );
                        }
                        WP_Log::debug( __METHOD__, ['$day'=>$day, '$repeater'=>$repeater ], 'wp-sukellos-fw' );

                        update_field( $this->get_acf_field_name().'_'.$day.'_range', $repeater, $post_id );
                    }
                } else {
                    // Closed to false
                    update_field( $this->get_acf_field_name().'_'.$day.'_closed', false, $post_id );
                    update_field( $this->get_acf_field_name().'_'.$day.'_open_24h', false, $post_id );

                    // Build repeater
                    $repeater = array();
                    foreach ( $times as $time_range ) {

                        $ranges = $this->format_time_range( $time_range );
                        if ( !empty( $ranges ) ) {

                            $repeater[] = array(
                                $this->get_acf_field_name().'_'.$day.'_opening' => $ranges['opening'] ,
                                $this->get_acf_field_name().'_'.$day.'_closing' => $ranges['closing'] ,
                            );
                        }
                    }
                    WP_Log::debug( __METHOD__, ['$day'=>$day, '$repeater'=>$repeater ], 'wp-sukellos-fw' );

                    update_field( $this->get_acf_field_name().'_'.$day.'_range', $repeater, $post_id );
                }
            }
        }
    }


    /**
     * Add missing 0 at end of beginning of hours
     * @param $time_str
     * @return mixed|string
     */
    private function complete_time_str( $time_str ) {

        if ( strlen( $time_str ) < 2 ) {

            $time_str = str_pad( $time_str, 2, '0', STR_PAD_LEFT );
            $time_str = str_pad( $time_str, 4, '0', STR_PAD_RIGHT );

        } else if ( strlen( $time_str ) < 3 ) {

            $time_str = str_pad( $time_str, 4, '0', STR_PAD_RIGHT );

        } else if ( strlen( $time_str ) < 4 ) {

            $time_str = str_pad( $time_str, 4, '0', STR_PAD_LEFT );

        }
        return $time_str;
    }

    /**
     * Format a date from Google format to H:i
     * @param $time_range
     * @return string|null
     */
    private function format_time_range( $time_range ) {

        WP_Log::debug( __METHOD__, ['$time_range'=>$time_range], 'wp-sukellos-fw' );
        $ranges = explode( '-', $time_range );

        if ( ( $ranges !== false ) && !empty( $ranges ) ) {

            if ( sizeof( $ranges ) == 3 ) {

                // Range in the same half day, as position 2
                $from = $this->complete_time_str( $ranges[ 0 ] );
                $to = $this->complete_time_str( $ranges[ 1 ] );
                $from_hd = strtolower( $ranges[ 2 ] );
                $to_hd = strtolower( $ranges[ 2 ] );

            } else if ( sizeof( $ranges ) == 4 ) {

                // Range NOT in the same half day, as position 1 and 3
                $from = $this->complete_time_str( $ranges[ 0 ] );
                $to = $this->complete_time_str( $ranges[ 2 ] );
                $from_hd = strtolower( $ranges[ 1 ] );
                $to_hd = strtolower( $ranges[ 3 ] );
            }

            // Convert into DateTime
            $time_from = DateTime::createFromFormat( 'hia', $from.$from_hd );
            $time_to = DateTime::createFromFormat( 'hia', $to.$to_hd );

            $result = array(
                'opening'=>$time_from->format( 'H:i' ),
                'closing'=>$time_to->format( 'H:i' ),
            );
            WP_Log::debug( __METHOD__, ['$result'=>$result], 'wp-sukellos-fw' );

            return $result;
        }
        return array();
    }
}
