<?php

namespace Sukellos\ScrapioAPI;

use Sukellos\WPFw\Api\WP_API_JSON_Request;

defined( 'ABSPATH' ) or exit;

/**
 * Scrapio request object.
 *
 * @since 1.0.0
 */
class WP_Scrapio_API_Request extends WP_API_JSON_Request {

    const REQUEST_SUBSCRIPTION = "subscription";
    const REQUEST_GMAP_TYPES = "gmap/types";
    const REQUEST_GMAP_LOCATIONS = "gmap/locations";
    const REQUEST_GMAP_PLACE = "gmap/place";
    const REQUEST_GMAP_SEARCH = "gmap/search";
    const REQUEST_GMAP_ENRICH = "gmap/enrich";
    const REQUEST_BLACKLIST = "blacklist";
    const REQUEST_BLACKLIST_ADD = "blacklist";
    const REQUEST_BLACKLIST_DELETE = "blacklist";

    /**
     * Build the request.
     *
     * @since 1.0.0
     *
     * @param $request String request in REQUEST_SUBSCRIPTION, REQUEST_GMAP_TYPES ...
     * @param $get_params GET query params
     * @param $args POST data
     * @param $method The request method, one of HEAD, GET, PUT, PATCH, POST, DELETE
     */
    public function __construct( $request, $get_params=array(), $post_data=array(), $method='GET' ) {

        $this->method = $method;
        $this->path   = $request;

        // Body data (if POST)
        if ( $method == 'POST' ) $this->data = $post_data;
        else if ( $method == 'GET' ) $this->params = $get_params;
    }
}
