<?php

namespace Sukellos\ScrapioAPI;


defined( 'ABSPATH' ) or exit;

/**
 *  Scrap.io item object.
 *
 * @since 1.0.0
 */
class WP_Scrapio_Item {

    protected $raw_data = null;

    /**
     * LEO2Click item contains generic data like id, name, desc, media
     *
     * @since 1.0.0
     *
     * @param string|object $raw_response a response as JSON object or JSON encoded string
     */
    public function __construct( $raw_data ) {

        $this->raw_data = $raw_data;
    }
    
    /**
     * Validate a item
     * 
     * @return boolean true is valid item, else false
     */
    public function validate() {

        return true;
    }

    
    /**
     * Get the string representation of this item.
     *
     * @since 1.0.0
     * @return string
     */
    public function __toString() {
        
        return json_encode((array)$this->raw_data);
    }
}