<?php

namespace Sukellos\ScrapioAPI;


defined( 'ABSPATH' ) or exit;

/**
 *  Scrap.io item object.
 *
 * @since 1.0.0
 */
class WP_Scrapio_Search extends WP_Scrapio_Item {

    //The above code returns JSON structured like this:
    //{
    //    "meta": {
    //        "count": "4092",
    //        "status": "completed",
    //        "next_cursor": "eyJnbWFwX3BsYWNlX2lkIjo0NTE0NjQsIl9wb2ludHNUb05leHRJdGVtcyI6dHJ1ZX0",
    //        "previous_cursor": null,
    //        "per_page": 10,
    //        "has_more_pages": true
    //    },
    //    "data": [
    //        {
    //            "google_id": "0x89c259a17dedfa2b:0x6f033e0043942344",
    //            "name": "SUGARFISH by sushi nozawa",
    //            "types": [
    //                {
    //                    "type": "restaurant",
    //                    "deleted": false,
    //                    "is_main": true
    //                },
    //                {
    //                    "type": "sushi-restaurant",
    //                    "deleted": false,
    //                    "is_main": false
    //                }
    //            ],
    //            "is_closed": false,
    //            "descriptions": [
    //                "SUGARFISH, a food-centric full-service restaurant, features a unique omakase-style service based on Nozawa’s 50 plus years of experience in Japan and the US. The menu features only tradition-based sushi of the highest quality, offered in four \"Trust Me®\" options, as well as an array of a la carte sashimi, sushi, and hand rolls made with carefully sourced fish, warm and loosely-packed rice, and crisp nori. SUGARFISH has locations in Los Angeles and New York City. For more information follow SUGARFISH on Instagram, Facebook and Twitter.",
    //                "Acclaimed sushi & sake destination",
    //                "Celebrated local sushi chain serving traditional rolls & sake in a chic, intimate space."
    //            ],
    //            "website": "https://sugarfishsushi.com/locations/flatiron",
    //            "phone": "+1 347-705-8100",
    //            "phone_international": "+13477058100",
    //            "timezone": "America/New_York",
    //            "location_full_address": "SUGARFISH by sushi nozawa, 33 E 20th St, New York, NY 10003, United States",
    //            "location_borough": "Manhattan",
    //            "location_street_1": "33 E 20th St",
    //            "location_street_2": "33 E 20th St",
    //            "location_city": "New York",
    //            "location_postal_code": "10003",
    //            "location_state": "New York",
    //            "location_latitude": "40.739001",
    //            "location_longitude": "-73.9888323",
    //            "location_country_code": "US",
    //            "location_admin1_code": "NY",
    //            "location_admin2_code": "061",
    //            "link": "https://www.google.com/maps/place/SUGARFISH+by+sushi+nozawa/data=!4m2!3m1!1s0x89c259a17dedfa2b:0x6f033e0043942344!10m1!1e1",
    //            "place_id": "ChIJK_rtfaFZwokRRCOUQwA-A28",
    //            "owner_name": "SUGARFISH by sushi nozawa",
    //            "owner_id": "100376796693654910584",
    //            "price_range": "$$$",
    //            "reviews_id": "7999305533994836804",
    //            "reviews_count": 1401,
    //            "reviews_rating": 4.5,
    //            "reviews_per_score": {
    //                "1": 78,
    //                "2": 28,
    //                "3": 67,
    //                "4": 194,
    //                "5": 1034
    //            },
    //            "photos_count": "1179+",
    //            "photos": {
    //                "0": "https://lh5.googleusercontent.com/p/AF1QipND93_nJUKC8a41_q3hsBPb4-PAtQbV-rvH0riE",
    //                "2": "https://lh5.googleusercontent.com/p/AF1QipOnX8thoIENmUO6Soi9ev88XaSHO0bVZQVcWFNC"
    //            },
    //            "characteristics": {
    //                "service-options": {
    //                    "delivery": "offers-delivery",
    //                    "takeout": "offers-takeout",
    //                    "dine-in": "serves-dine-in"
    //                },
    //                "health-and-safety": {
    //                    "staff-required-to-disinfect-surfaces-between-visits": "staff-required-to-disinfect-surfaces-between-visits"
    //                },
    //                "highlights": {
    //                    "great-tea-selection": "has-great-tea-selection"
    //                },
    //                "popular-for": {
    //                    "lunch": "popular-for-lunch",
    //                    "dinner": "popular-for-dinner",
    //                    "solo-dining": "good-for-solo-dining"
    //                },
    //                "accessibility": {
    //                    "wheelchair-accessible-entrance": "has-wheelchair-accessible-entrance",
    //                    "wheelchair-accessible-parking-lot": "no-wheelchair-accessible-parking-lot"
    //                },
    //                "offerings": {
    //                    "alcohol": "serves-alcohol",
    //                    "beer": "serves-beer",
    //                    "healthy-options": "serves-healthy-options",
    //                    "small-plates": "serves-small-plates",
    //                    "wine": "serves-wine"
    //                },
    //                "dining-options": {
    //                    "lunch": "serves-lunch",
    //                    "dinner": "serves-dinner",
    //                    "seating": "has-seating"
    //                },
    //                "atmosphere": {
    //                    "casual": "casual",
    //                    "cozy": "cozy",
    //                    "upscale": "upscale"
    //                },
    //                "crowd": {
    //                    "tourists": "popular-with-tourists"
    //                },
    //                "planning": {
    //                    "usually-a-wait": "usually-has-a-wait"
    //                },
    //                "payments": {
    //                    "debit-cards": "accepts-debit-cards"
    //                }
    //            },
    //            "occupancy": {
    //                "monday": null,
    //                "tuesday": {
    //                    "6 a.m.": "closed",
    //                    "7 a.m.": "closed",
    //                    "8 a.m.": "closed",
    //                    "9 a.m.": "closed",
    //                    "10 a.m.": "closed",
    //                    "11 a.m.": "usually-not-too-busy",
    //                    "12 p.m.": "usually-not-too-busy",
    //                    "1 p.m.": "usually-not-too-busy",
    //                    "2 p.m.": "usually-a-little-busy",
    //                    "3 p.m.": "usually-a-little-busy",
    //                    "4 p.m.": "usually-a-little-busy",
    //                    "5 p.m.": "usually-a-little-busy",
    //                    "6 p.m.": "usually-as-busy-as-it-gets",
    //                    "7 p.m.": "usually-as-busy-as-it-gets",
    //                    "8 p.m.": "usually-a-little-busy",
    //                    "9 p.m.": "usually-a-little-busy",
    //                    "10 p.m.": "usually-not-too-busy",
    //                    "11 p.m.": "closed"
    //                },
    //                "wednesday": {
    //                    "6 a.m.": "closed",
    //                    "7 a.m.": "closed",
    //                    "8 a.m.": "closed",
    //                    "9 a.m.": "closed",
    //                    "10 a.m.": "closed",
    //                    "11 a.m.": "usually-not-too-busy",
    //                    "12 p.m.": "usually-not-too-busy",
    //                    "1 p.m.": "usually-not-too-busy",
    //                    "2 p.m.": "usually-a-little-busy",
    //                    "3 p.m.": "usually-a-little-busy",
    //                    "4 p.m.": "usually-a-little-busy",
    //                    "5 p.m.": "usually-a-little-busy",
    //                    "6 p.m.": "usually-as-busy-as-it-gets",
    //                    "7 p.m.": "usually-as-busy-as-it-gets",
    //                    "8 p.m.": "usually-a-little-busy",
    //                    "9 p.m.": "usually-a-little-busy",
    //                    "10 p.m.": "usually-not-too-busy",
    //                    "11 p.m.": "closed"
    //                },
    //                "thursday": {
    //                    "6 a.m.": "closed",
    //                    "7 a.m.": "closed",
    //                    "8 a.m.": "closed",
    //                    "9 a.m.": "closed",
    //                    "10 a.m.": "closed",
    //                    "11 a.m.": "usually-not-too-busy",
    //                    "12 p.m.": "usually-a-little-busy",
    //                    "1 p.m.": "usually-a-little-busy",
    //                    "2 p.m.": "usually-a-little-busy",
    //                    "3 p.m.": "usually-a-little-busy",
    //                    "4 p.m.": "usually-a-little-busy",
    //                    "5 p.m.": "usually-a-little-busy",
    //                    "6 p.m.": "usually-a-little-busy",
    //                    "7 p.m.": "usually-as-busy-as-it-gets",
    //                    "8 p.m.": "usually-a-little-busy",
    //                    "9 p.m.": "usually-a-little-busy",
    //                    "10 p.m.": "usually-not-too-busy",
    //                    "11 p.m.": "closed"
    //                },
    //                "friday": {
    //                    "6 a.m.": "closed",
    //                    "7 a.m.": "closed",
    //                    "8 a.m.": "closed",
    //                    "9 a.m.": "closed",
    //                    "10 a.m.": "closed",
    //                    "11 a.m.": "usually-not-too-busy",
    //                    "12 p.m.": "usually-a-little-busy",
    //                    "1 p.m.": "usually-a-little-busy",
    //                    "2 p.m.": "usually-a-little-busy",
    //                    "3 p.m.": "usually-a-little-busy",
    //                    "4 p.m.": "usually-a-little-busy",
    //                    "5 p.m.": "usually-a-little-busy",
    //                    "6 p.m.": "usually-as-busy-as-it-gets",
    //                    "7 p.m.": "usually-as-busy-as-it-gets",
    //                    "8 p.m.": "usually-as-busy-as-it-gets",
    //                    "9 p.m.": "usually-as-busy-as-it-gets",
    //                    "10 p.m.": "usually-a-little-busy",
    //                    "11 p.m.": "usually-not-too-busy"
    //                },
    //                "saturday": {
    //                    "6 a.m.": "closed",
    //                    "7 a.m.": "closed",
    //                    "8 a.m.": "closed",
    //                    "9 a.m.": "closed",
    //                    "10 a.m.": "closed",
    //                    "11 a.m.": "usually-not-too-busy",
    //                    "12 p.m.": "usually-not-too-busy",
    //                    "1 p.m.": "usually-a-little-busy",
    //                    "2 p.m.": "usually-a-little-busy",
    //                    "3 p.m.": "usually-a-little-busy",
    //                    "4 p.m.": "usually-a-little-busy",
    //                    "5 p.m.": "usually-a-little-busy",
    //                    "6 p.m.": "usually-as-busy-as-it-gets",
    //                    "7 p.m.": "usually-as-busy-as-it-gets",
    //                    "8 p.m.": "usually-a-little-busy",
    //                    "9 p.m.": "usually-a-little-busy",
    //                    "10 p.m.": "usually-a-little-busy",
    //                    "11 p.m.": "usually-not-too-busy"
    //                },
    //                "sunday": {
    //                    "6 a.m.": "closed",
    //                    "7 a.m.": "closed",
    //                    "8 a.m.": "closed",
    //                    "9 a.m.": "closed",
    //                    "10 a.m.": "closed",
    //                    "11 a.m.": "closed",
    //                    "12 p.m.": "usually-not-too-busy",
    //                    "1 p.m.": "usually-not-too-busy",
    //                    "2 p.m.": "usually-a-little-busy",
    //                    "3 p.m.": "usually-a-little-busy",
    //                    "4 p.m.": "usually-a-little-busy",
    //                    "5 p.m.": "usually-a-little-busy",
    //                    "6 p.m.": "usually-a-little-busy",
    //                    "7 p.m.": "usually-a-little-busy",
    //                    "8 p.m.": "usually-a-little-busy",
    //                    "9 p.m.": "usually-not-too-busy",
    //                    "10 p.m.": "usually-not-too-busy",
    //                    "11 p.m.": "closed"
    //                }
    //            },
    //            "is_claimed": true,
    //            "working_hours": {
    //                "monday": "closed",
    //                "tuesday": "1130am-11pm",
    //                "wednesday": "1130am-11pm",
    //                "thursday": "1130am-11pm",
    //                "friday": "1130am-12am",
    //                "saturday": "1130am-12am",
    //                "sunday": "12-11pm"
    //            },
    //            "status": "completed",
    //            "scraped_at": "2022-07-04T10:24:57.000000Z",
    //            "first_seen_at": "2021-04-12T16:25:50.000000Z",
    //            "website_data": {
    //                "url": "https://sugarfishsushi.com/locations/flatiron",
    //                "domain": "sugarfishsushi.com",
    //                "is_responding": true,
    //                "is_empty": null,
    //                "title": "Flatiron – SUGARFISH",
    //                "meta_keywords": null,
    //                "meta_description": null,
    //                "meta_og_title": null,
    //                "meta_og_image": null,
    //                "meta_generator": "WordPress 5.8.4",
    //                "lang": "en",
    //                "contact_pages": [
    //                    "https://sugarfishsushi.com/contact-us"
    //                ],
    //                "facebook": [
    //                    "https://facebook.com/sugarfishsushi"
    //                ],
    //                "youtube": null,
    //                "twitter": [
    //                    "https://twitter.com/sugarfish"
    //                ],
    //                "instagram": [
    //                    "https://instagram.com/sugarfishbynozawa"
    //                ],
    //                "linkedin": null,
    //                "technologies": [
    //                    "Apache",
    //                    "Google Analytics",
    //                    "WordPress",
    //                    "PHP",
    //                    "MySQL"
    //                ],
    //                "ad_pixels": [
    //                    "Google Tag Manager"
    //                ],
    //                "emails": [
    //                    {
    //                        "email": "flatiron@sugarfishsushi.com",
    //                        "sources": [
    //                            "https://sugarfishsushi.com/locations/flatiron"
    //                        ]
    //                    },
    //                    {
    //                        "email": "eat@sugarfishsushi.com",
    //                        "sources": [
    //                            "https://sugarfishsushi.com/locations/flatiron"
    //                        ]
    //                    }
    //                ],
    //                "phones": null,
    //                "status": "completed",
    //                "scraped_at": "2022-07-04T10:24:53.000000Z"
    //            }
    //        },
    //        ...
    //    ]
    //}

    public function get_count() {

        return $this->raw_data->meta->count;
    }

    public function get_status() {

        return $this->raw_data->meta->status;
    }

    public function get_next_cursor() {

        return $this->raw_data->meta->next_cursor;
    }

    public function get_previous_cursor() {

        return $this->raw_data->meta->previous_cursor;
    }

    public function get_per_page() {

        return $this->raw_data->meta->per_page;
    }

    public function has_more_pages() {

        return $this->raw_data->meta->has_more_pages;
    }

    /**
     * Return an array of data (gmap entities)
     * @return mixed
     */
    public function get_data() {

        return $this->raw_data->data;
    }

}