<?php

namespace Sukellos\ScrapioAPI;


defined( 'ABSPATH' ) or exit;

/**
 *  Scrap.io item object.
 *
 * @since 1.0.0
 */
class WP_Scrapio_Subscription extends WP_Scrapio_Item {

    //The above code returns JSON structured like this:
    //
    //{
    //    "plan": "Partner plan",
    //    "active": true,
    //    "on_trial": false,
    //    "pending_cancelation": false,
    //    "renewal_date": "2022-08-05T15:13:18.000000Z",
    //    "features": {
    //    "EXPORT_CREDITS": {
    //        "name": "Export credits",
    //            "consumed": 0,
    //            "remaining": 100000,
    //            "total": 100000
    //        },
    //        "SCRAPING_SPEED": {
    //        "name": "Scraping speed",
    //            "value": "Very high"
    //        },
    //        "SEARCH_CITY": {
    //        "name": "Search by city",
    //            "value": true
    //        },
    //        "SEARCH_ADMIN2_CODE": {
    //        "name": "Search by level 2 division",
    //            "value": true
    //        },
    //        "SEARCH_ADMIN1_CODE": {
    //        "name": "Search by level 1 division",
    //            "value": true
    //        },
    //        "SEARCH_WHOLE_COUNTRY": {
    //        "name": "Search on whole country",
    //            "value": true
    //        },
    //        "ESSENTIAL_SEARCH_FILTERS": {
    //        "name": "Essential search filters",
    //            "value": true
    //        },
    //        "ADVANCED_SEARCH_FILTERS": {
    //        "name": "Advanced search filters",
    //            "value": true
    //        },
    //        "GMAP_EXPORT_ADDITIONAL_FIELDS": {
    //        "name": "GMap additional fields in exports",
    //            "value": true
    //        },
    //        "WEB_EXPORT_ADDITIONAL_FIELDS": {
    //        "name": "Website additional fields in exports",
    //            "value": true
    //        },
    //        "API_ACCESS": {
    //        "name": "API Access",
    //            "value": true
    //        }
    //    }
    //}

    public function get_plan() {

        return $this->raw_data->plan;
    }

    public function is_active() {

        return $this->raw_data->active;
    }

    public function is_on_trial() {

        return $this->raw_data->on_trial;
    }

    public function is_pending_cancelation() {

        return $this->raw_data->pending_cancelation;
    }

    public function get_renewal_date() {

        return $this->raw_data->renewal_date;
    }


    public function get_export_credits_name() {
        return $this->raw_data->features->EXPORT_CREDITS->name;
    }

    public function get_export_credits_consumed() {
        return $this->raw_data->features->EXPORT_CREDITS->consumed;
    }

    public function get_export_credits_remaining() {
        return $this->raw_data->features->EXPORT_CREDITS->remaining;
    }

    public function get_export_credits_total() {
        return $this->raw_data->features->EXPORT_CREDITS->total;
    }

    public function get_scraping_speed_name() {
        return $this->raw_data->features->SCRAPING_SPEED->name;
    }

    public function get_scraping_speed_value() {
        return $this->raw_data->features->SCRAPING_SPEED->value;
    }

    public function get_search_city_name() {
        return $this->raw_data->features->SEARCH_CITY->name;
    }

    public function is_search_city_active() {
        return $this->raw_data->features->SEARCH_CITY->value;
    }

    public function get_search_admin2_code_name() {
        return $this->raw_data->features->SEARCH_ADMIN2_CODE->name;
    }

    public function is_search_admin2_code_active() {
        return $this->raw_data->features->SEARCH_ADMIN2_CODE->value;
    }

    public function get_search_admin1_code_name() {
        return $this->raw_data->features->SEARCH_ADMIN1_CODE->name;
    }

    public function is_search_admin1_code_active() {
        return $this->raw_data->features->SEARCH_ADMIN1_CODE->value;
    }

    public function get_search_whole_country_name() {
        return $this->raw_data->features->SEARCH_WHOLE_COUNTRY->name;
    }

    public function is_search_whole_country_active() {
        return $this->raw_data->features->SEARCH_WHOLE_COUNTRY->value;
    }

    public function get_essential_search_filters_name() {
        return $this->raw_data->features->ESSENTIAL_SEARCH_FILTERS->name;
    }

    public function is_essential_search_filters_active() {
        return $this->raw_data->features->ESSENTIAL_SEARCH_FILTERS->value;
    }

    public function get_advanced_search_filters_name() {
        return $this->raw_data->features->ADVANCED_SEARCH_FILTERS->name;
    }

    public function is_advanced_search_filters_active() {
        return $this->raw_data->features->ADVANCED_SEARCH_FILTERS->value;
    }

    public function get_gmap_export_additional_fields_name() {
        return $this->raw_data->features->GMAP_EXPORT_ADDITIONAL_FIELDS->name;
    }

    public function is_gmap_export_additional_fields_active() {
        return $this->raw_data->features->GMAP_EXPORT_ADDITIONAL_FIELDS->value;
    }

    public function get_web_export_additional_fields_name() {
        return $this->raw_data->features->WEB_EXPORT_ADDITIONAL_FIELDS->name;
    }

    public function is_web_export_additional_fields_active() {
        return $this->raw_data->features->WEB_EXPORT_ADDITIONAL_FIELDS->value;
    }

    public function get_api_access_name() {
        return $this->raw_data->features->API_ACCESS->name;
    }

    public function is_api_access_active() {
        return $this->raw_data->features->API_ACCESS->value;
    }

}